using System;
using System.Text;
using Unit4.CollectionsLib;
using Unit4.UtilsLib;
/**
 *   :   
 * @author  , '  
 * @version 3/1/2007
 */
namespace TestCarWash
{
    class CarWash
    {
        //          
	    private Map<CarWashData> carMap ;
	    public const int BOUNDARY_OF_WASHES = 5;
	    public const int PRICE_FOR_FIRSTS_EXTERNAL_WASHES = 20;
	    public const int PRICE_FOR_FIRSTS_COMBINED_WASHES = 30;
	    public const int PRICE_FOR_LASTS_EXTERNAL_WASHES = 18;
	    public const int PRICE_FOR_LASTS_COMBINED_WASHES = 24;
    	 
	    public CarWash()
	    {
		    this.carMap = new Map<CarWashData>();
	    }
    	 
	    public Boolean CarExists(int carNum)
	    {
            String carString = carNum.ToString();
            return (this.carMap.ContainsKey(carString));
	    }
    	
	    public int AddWashForCar (int carNum, int type, Date date) 
	    {
            String carString = carNum.ToString();

            if (!CarExists(carNum))
			    this.carMap.Insert(carString,new CarWashData());
		    CarWashData carWashData = this.carMap.GetValue(carString);
		    int washTimes = carWashData.GetTotalWashes();
    		
		    carWashData.AddWash(date,type);
		    carWashData.AddTotalWashes();
		    if (type==1)
			    carWashData.AddType1Washes();
		    else
			    carWashData.AddType2Washes();
    		
		    if (washTimes < BOUNDARY_OF_WASHES)
			    if ( type ==1)
				    return PRICE_FOR_FIRSTS_EXTERNAL_WASHES;
			    else
				    return PRICE_FOR_FIRSTS_COMBINED_WASHES;
		    else
		       if (type==1)
			      return PRICE_FOR_LASTS_EXTERNAL_WASHES;
		       else
			      return PRICE_FOR_LASTS_COMBINED_WASHES;
	    }
    	
	    public void PrintAllWashes(int carNum)
	    {
		    if (!CarExists(carNum))
			    Console.WriteLine("no washes for car " + carNum);
		    else
		    {
			    String carString = carNum.ToString();
			    CarWashData carWashData = this.carMap.GetValue(carString);
			    Node<Wash> pos = carWashData.GetCarWashList().GetFirst();
			    int i=1;
			    while (pos != null)
			    {
                    Console.WriteLine("Date" + i + ":" + pos.GetInfo().GetDate()
						       +" Type:"+pos.GetInfo().GetCarType());
				    pos = pos.GetNext();
				    i++;
			    }
		    }
	    }
    	
	    public void PrintTotalWashesByType()
	    {
            Console.WriteLine("Total washes by type:");
		    String[] cars = this.carMap.GetAllKeys();
		    for (int i=0; i<cars.Length; i++)
                Console.WriteLine("Car number: " + cars[i] + " had " +
					    this.carMap.GetValue(cars[i]).GetType1Washes() +" external washes and " +
					    this.carMap.GetValue(cars[i]).GetType2Washes() +" combined washes.");
	    }
    	
	    public void PrintAllWashesBetweenDates(Date fromDate,Date toDate)
	    {
            String[] cars = this.carMap.GetAllKeys();
            Console.WriteLine("All washes between " + fromDate + " and " + toDate + ":");
		    for (int i=0; i<cars.Length; i++)
		    {
			    bool first = true;
			    CarWashData carWashData = this.carMap.GetValue(cars[i]);
			    Node<Wash> pos = carWashData.GetCarWashList().GetFirst();
			    while (pos != null)
			    {
				    Date date = pos.GetInfo().GetDate();
				    if (!date.Before(fromDate) && date.Before(toDate))
				    {
					    if (first)
					    {
                            Console.WriteLine("car number " + cars[i] + ":");
						    first = false;
					    }
                        Console.WriteLine("Date:" + date + " Type:" + pos.GetInfo().GetCarType());
				    }
				    pos = pos.GetNext();
			    }
		    }
	    }

    }
}
